/*
 * Mocha 
 * Copyright (c) 2005 IT Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file AppSndDev.h
 *
 * This file implements the APIs of Application Sound Manager.
 *
 * @author	mobum
 */
/*:Associate with "Application Sound Manager" */

#ifndef _APP_SND_DEV_H_
#define _APP_SND_DEV_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * Public Function Prototypes
 */
 
// Local calls
#if defined(_SHP_DLL_APPSNDMGR) || ( ! defined(_SHP_DLL) && ! defined(_SHP_CALL_DLL_APPSNDMGR))

// Enable/Disable
void	AppSndEnableDevSound				( void );
void	AppSndDisableDevSound				( void );

/* Flip */
// Mute
BOOL	__AppSndMuteFlipSound				( const char* const pszFile, int nLine );
BOOL	__AppSndUnmuteFlipSound				( const char* const pszFile, int nLine );
BOOL	AppSndGetMutedFlipSound				( AppSndMuteType* const pMuteType );

#endif // defined(_SHP_DLL_APPSNDMGR) || ( ! defined(_SHP_DLL) && ! defined(_SHP_CALL_DLL_APPSNDMGR))

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _APP_SND_DEV_H_
