/*
 * Mocha
 * Copyright (c) 2002 Software Center, Samsung Electronics, Inc.
 * All right reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics
 */

#ifndef _CERT_TYPES_
#define _CERT_TYPES_

#ifdef __cplusplus
extern "C"
{
#endif

#include "ShpTypes.h"

#define		MAX_CERTIFICATE_SIZE			2048

typedef enum 
{
  	CERT_FORMAT_X509=1,	
  	CERT_FORMAT_WTLS=3,	
	CERT_FORMAT_WAP=4,	
	CERT_FORMAT_UNKNOWN=5,	
}CmCertFormat;

typedef enum
{
	CERTTYPE_NOT_BOUNDED		= 0,
	CERTTYPE_PRIVATE = 1,
	CERTTYPE_UNTRUSTED = 2,
	CERTTYPE_TRUSTED_CA = 3, 			
	CERTTYPE_ROOT_CA = 4,     			
	CERTTYPE_ROOT_DOMAIN1 =5,     		
	CERTTYPE_ROOT_DOMAIN2 = 6 ,   		
	CERTTYPE_ROOT_DOMAIN3 = 7,     		
	CERTTYPE_SIM_ROOT_DOMAIN1	= 8,	
	CERTTYPE_SIM_ROOT_WTLS		= 9,	
	CERTTYPE_SIM_ROOT_DOMAIN3	= 10,	
	CERTTYPE_DEV_ROOT_CA		= 11,
	CERTTYPE_DEV_ROOT_DOMAIN1	= 12,
	CERTTYPE_DEV_ROOT_DOMAIN2	= 13,
	CERTTYPE_DEV_ROOT_DOMAIN3	= 14,

	CERTTYPE_MAX,

} CertType;


typedef struct _tagRootCertList
{
	CmCertFormat	format;		
	UINT32			length;	
	UINT8			certificate[MAX_CERTIFICATE_SIZE];	

	struct _tagRootCertList	*pNext;		

} CmRootCertList;

#define		PKCS15_MAX_LABEL_SIZE		32

typedef enum
{
	CM_OCSP_TYPE_GOOD,
	CM_OCSP_TYPE_REVOKED,

} CmOcspType;


typedef struct
{
	CmOcspType		type;
	char			*pRevokedTime;
	char			*pRevokedReason;

} CmOcspResult;

typedef BOOL	(*CmCertOcspCB)(CmOcspResult  *pOcspResult);

#ifdef __cplusplus
}
#endif

#endif /* _CERT_TYPES_ */