/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "Device Manager" */

#ifndef _DEV_CLK_ECOM_H_
#define _DEV_CLK_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "OsAL.h"

/*
 * ECOM Interface
 */
ECOM_INTERFACE(EDevClk)
{
	DECLARE_EBASE()

	void	(*ResetElapsedTime)(void);
	ULONG	(*GetElapsedTime)(void);
	ULONG	(*GetTime)(void);
	void	(*SetTime)(ULONG seconds);
	BOOL	(*GetUptime)(ULONG* seconds, ULONG* milliSeconds);
};

/*
 * Interface Accessor
 */
// Native/DLL Call
#if (defined(_SHP_SIMUL) && defined(_SHP_CALL_DLL_DEVMGR_DEVCLK)) || (defined(_SHP_DLL) && ! defined(_SHP_DLL_DEVMGR_DEVCLK) && ! defined(_SHP_CALL_DLL_DEVMGR_DEVCLK))
#	define ClkDispatch	 (__ClkGetVtbl()->Dispatch)
#	define ClkResetElapsedTime	(__ClkGetVtbl()->ResetElapsedTime)
#	define ClkGetElapsedTime	(__ClkGetVtbl()->GetElapsedTime)
#	define ClkGetTime			(__ClkGetVtbl()->GetTime)
#	define ClkSetTime			(__ClkGetVtbl()->SetTime)
#endif // _SHP_DLL


/*
 * ECOM Type
 */
typedef struct
{
	DECLARE_ECOM_VTBL(EDevClk)
	UINT32		refCount;
} TDevClk;

extern TDevClk devClk;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _DEV_CLK_ECOM_H_
