/*
 * Mocha
 * Copyright (c) 2000-2003 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "Device Flip" */

#ifndef _DEV_FLIP_ECOM_H_
#define _DEV_FLIP_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * ECOM Interface
 */
ECOM_INTERFACE(EDevFlip)
{
	DECLARE_EBASE()
	
	BOOL	(*IsOpened)(void);

	void	(*FlipRotateInd)	(int degree);
	int		(*GetDegreeRotated)	(void);
};

/*
 * Interface Accessor
 */
#if (defined(_SHP_SIMUL) && defined(_SHP_CALL_DLL_DEVMGR_DEVFLIP)) || (defined(_SHP_DLL) && ! defined(_SHP_DLL_DEVMGR_DEVFLIP) && ! defined(_SHP_CALL_DLL_DEVMGR_DEVFLIP))
#	 define FlipDispatch 		(__FlipGetVtbl()->Dispatch)
#    define FlipIsOpened		(__FlipGetVtbl()->IsOpened)

#	 define OemFlipRotateInd    (__FlipGetVtbl()->FlipRotateInd)
#	 define FlipGetDegreeRotated (__FlipGetVtbl()->GetDegreeRotated)
#endif // _SHP_DLL

/*
 * ECOM Type
 */
 typedef enum
{
	FLIP_OPEN_HORIZENTAL 	= 0,
	FLIP_OPEN_VERTICAL 	= 1
}FlipOpenType;

typedef struct
{
	DECLARE_ECOM_VTBL(EDevFlip)
	UINT32		refCount;
} TDevFlip;

extern TDevFlip devFlip;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _DEV_FLIP_ECOM_H_
