/*
 * Mocha
 * Copyright (c) 2000-2002 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/*:Associate with "Device Manager" */

#ifndef _DEV_LCD_ECOM_H_
#define _DEV_LCD_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * ECOM Interface
 */
ECOM_INTERFACE(EDevLCD)
{
	DECLARE_EBASE()
	
	void	(*SetBacklight)(LcdType type, BOOL bOn, char * szFileName, int nLine);
	void	(*SetBrightness)(LcdType type, int brightness, char * szFileName, int nLine);
	BOOL	(*SetIcon)( LcdIconType iconType, BOOL bOn, int level );
	BOOL	(*TurnOff)( LcdType type );
};

/*
 * Interface Accessor
 */
// Native/DLL Call
#if (defined(_SHP_SIMUL) && defined(_SHP_CALL_DLL_DEVMGR_DEVLCD)) || (defined(_SHP_DLL) && ! defined(_SHP_DLL_DEVMGR_DEVLCD) && ! defined(_SHP_CALL_DLL_DEVMGR_DEVLCD))
#	define LcdDispatch 		(__LcdGetVtbl()->Dispatch)
#	define LcdSetBacklight	(__LcdGetVtbl()->SetBacklight)
#	define LcdSetBrightness	(__LcdGetVtbl()->SetBrightness)
#endif // _SHP_DLL

/*
 * ECOM Type
 */
typedef struct
{
	DECLARE_ECOM_VTBL(EDevLCD)
	UINT32		refCount;
} TDevLCD;

extern TDevLCD devLcd;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _DEV_LCD_ECOM_H_
