/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "Device Manager" */

#ifndef _DEV_TYPES_H_
#define _DEV_TYPES_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "Shp.h"

/*
 * Device Drivers
 */
typedef enum
{ 
	DEV_EEPROM,			/* EEPROM */
	DEV_FLASH_MEM,		/* Flash Memory */
	DEV_LED,			/* LED */
	DEV_LCD,			/* LCD */
	DEV_SOUND,			/* Sound */
	DEV_UART,			/* Serial */
	DEV_CLK,
	DEV_PHONE_STATUS,	/* Phone Status like Battery, SMS... */
	DEV_SIM,			/* SIM, USIM, WIM, ... */
	DEV_FIFO			/* FIFO (Dual Port RAM) */
} DeviceType;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _DEV_TYPES_H_
