/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
 
/*:Associate with "System Manager" */

#ifndef _SYS_ERROR_H_
#define _SYS_ERROR_H_

#include "SysDebug.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define GET_ERROR(X)	GETMSK(X, 16, MASKL16)
#define SET_ERROR(X)	((X & MASKL16) << 16)

/*
 * Error codes
 */
#define NOERR				0x00

#include "OemSysError.h"

/* Language Library */
#define WMERR_INVALID_UNICODE_RANGE		(MID_CRAYON + SET_ERROR(0x0040)) // Invalid unicode range



extern UINT32 gErrno;	/* Error number */

/*
 * Protected Function Prototypes
 */
// Local calls
#if defined(_SHP_DLL_DLLMGR) || ( ! defined(_SHP_DLL) && ! defined(_SHP_CALL_DLL_DLLMGR))
void SysSetLastError(UINT32 err);
UINT32 SysGetLastError(void);
#else
#	define SysSetLastError			(__SysGetVtbl()->SetLastError)
#	define SysGetLastError			(__SysGetVtbl()->GetLastError)
#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _SYS_ERROR_H_
