/** 
* Samsung Handset Platform
* Copyright (c) 2006 Samsung Electronics, Inc.
* All rights reserved. 
*
* This software is the confidential and proprietary information
* of Samsung Electronics, Inc. ("Confidential Information").  You
* shall not disclose such Confidential Information and shall use
* it only in accordance with the terms of the license agreement
* you entered into with Samsung Electronics.
*/
/*
*  This defines the  type defines used in browser modules.
*  @author Naveen Kumar SG(naveensg@samsung.com)
*  @author Sneha Bhat(sneha.bhat@samsung.com)
*/

#ifndef _SFBAL_DEF_SHP_H_
#define _SFBAL_DEF_SHP_H_

#include "SFBalConfigShp.h"


#ifndef BOOL
#define BOOL  int
#endif

#ifndef HObj
#define HObj int
#endif


#define SFB_INVALID_HOBJ  -1
#define BAL_CRLF "\x0d\x0a"

#ifndef SFB_DEBUG_MEMORY
//#define SFB_DEBUG_MEMORY
#endif

#define BalFile			BalFile_macro

typedef INT32                     BalDir;
typedef UINT32                    BalFileMode;
typedef UINT32                    BalFileStat ;

/*The BalFileMode is as follows*/

#define BAL_FILE_CREATE	       0x0001		
#define BAL_FILE_READ		0x0002
#define BAL_FILE_WRITE		0x0004
#define BAL_FILE_TRUNCATE	0x0008
#define BAL_FILE_APPEND	0x0010
#define BAL_FILE_DIR		0x00000200	
#define BAL_FILE_READONLY	0x00000400
#define BAL_FILE_HIDDEN		0x00000800
#define BAL_FILE_SYSTEM		0x00001000

#define	BAL_EXTENSION_STRING_LEN_MAX		5
#define BAL_FM_TEMP_FILE_PATH_PHONE		"/User/Tmp"
#define BAL_FM_TEMP_FILE_PATH_MEMORY		"/Mount/Mmc"
#define BAL_FILENAME_STR_LEN_MAX		46
#define	BAL_FM_SLASH_CHAR				'/'
#define	BAL_FM_SLASH					"/"

// You can OR these definition. ex. SFBalDebug( DI_UI | BAL_NET, "" );
#define		BAL_UI				0x01			// UI related debug msg.
#define		BAL_NET			0x02			// Network related debug msg including cache, cookie, rm, ...
#define		BAL_CD				0x04			// Cotent Downloader related debug msg
#define		BAL_PERF			0x08			// Performance related debug msg
#define		BAL_LAYOUT		0x10			// redering engine related debug msg
#define		BAL_EVENT		0x20			// event handling related msg
#define		BAL_COMMON	0x40			// general debug msg
#define		BAL_MEM			0x80			// memory related debug msg



#define BAL_WEBCORE			0x0001	      //WebCore related debug Msg.
#define BAL_JAVACORE			0x0002	      //JavaCore related debug Msg.
#define BAL_WEBKIT			       0x0004	      // WEb kit Related Debg Msg.




#define		BAL_EXCEPTION		BAL_EXCEPTION_MACRO

typedef int SFBResult;
#define SFB_STATUS_OK 0 // Basav
#define SFB_RM_WSP
#define SFB_RM_UNZIP
#define SFB_RM_POST_TO_GET

typedef enum
{
	BAL_FM_STORAGE_NONE,

	BAL_FM_STORAGE_PHONE,

#ifndef _BROWSER_MODEL_SUPREME
	BAL_FM_STORAGE_PHONE_USER,
#endif

	BAL_FM_STORAGE_MEMORY,
	BAL_FM_STORAGE_SIM,

	BAL_FM_STORAGE_USER,

	BAL_FM_STORAGE_MAX

} SFBalFmStorageType;


typedef enum{

	BAL_SEEK_SET=0,
	BAL_SEEK_CUR, 
	BAL_SEEK_END 

}SFBalFileSeekParams;


typedef enum
{
	BAL_INVALID_TYPE =0x0000, 
	BAL_FILE_TYPE = 0x0001,
	BAL_DIR_TYPE = 0x0002,		

} SFBalFileType;


typedef int BalTimer;

typedef struct
{
	INT32		year;
	INT32		month;
	INT32		day;
	INT32		hour;
	INT32		minute;
	INT32		second;
} SFBalDateTime;


typedef struct
{
	UINT32		fileSize;				/* File size */
	BalFileStat	attribute;			/* file attribute like directory or file, hidden, readonly, system*/	
	SFBalDateTime 		cTime;			/* Creation date/time */
	UINT32		allocatedSize;		/* real allocated size of file & directory in sub System */

} SFBalFileAttributes;


typedef struct
{
	SFBalFileType	type;			/*whether it is file or dir */
	UINT32		fileSize;			/*file size*/
	UINT32		attribute;		/* Attribute */
	SFBalDateTime	ctime;			/* file create date/time */
	char			fileName[BAL_FILEPATH_MAX_LEN];		/* File name */
	UINT32		allocatedSize;	/* real allocated size of file or directory on the  System */
									
} SFBalDirEntry;

typedef struct{

	char *extn;
	char *mimeType;

}SFBalContentTypeStruct;



#ifndef CRLF
#define CRLF "\x0d\x0a"
#endif /* CRLF */


#endif

