/*
* ==============================================================================
*  Name        : BrowserControl_Cache_Interface.h
*  Part of     : Browser Control
*  Description : Cache interface for the growser control.
*  Version     :
*
*    Copyright (c) 2007,
*    All rights reserved.
* ==============================================================================
*/
#ifndef __BROWSERCONTROL_CACHE_INTERFACE_H__
#define __BROWSERCONTROL_CACHE_INTERFACE_H__

#include "BrowserControl_DataTypes.h"

extern "C"
{

/**
 * @defgroup Cache Cache related APIs
 */

//------------------------------------------------------------------------
// Cache Interface API
//------------------------------------------------------------------------

/**
*  BrowserControl_DeleteCache
* @brief Purpose : Deletes the in-memory cache used by this instance of
* the Browser control.
* @param IHANDLE aBrowserHandle : Handle to the BrowserControl.
* @return ESTATUS : ESUCCESS if the cache was deleted,else EFAIL.Exact reason
* of the failure can be queried using BrowserControl_GetLastError().
* @ingroup Cache
*/
WEBKIT_SHP_API ESTATUS BrowserControl_DeleteCache(HANDLE aBrowserHandle);

/**
*  BrowserControl_DeleteCookies
* @brief Purpose : Delete cookies stored by the present instance of the
* browser control.
* @param IHANDLE aBrowserHandle : Handle to the BrowserControl.
* @return ESTATUS : ESUCCESS if the cookies were deleted,else EFAIL.Exact
* reason of the failure can be queried using BrowserControl_GetLastError().
* @ingroup Cache
*/
WEBKIT_SHP_API ESTATUS BrowserControl_DeleteCookies(HANDLE aBrowserHandle);

} //extern "C"

#endif //__BROWSERCONTROL_CACHE_INTERFACE_H__
