/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */
/**
 * @file		PerfLog.cpp
 * @brief		
 * @author	Sangheon Kim (sangheon77.kim@samsung.com) @n
					
 * @version	1.0
 * @date		2008.09.10	v1.0		Created							shkim @n
 */

//
//#include "Shp.h"
//#include "ShpJasmine.h" 
//#include "MemMgr.h"
//#include <map>
//
//#define INVALID_TICK 0xffffffff
//#define PERFLOG_PATH "/User/Br/perflog.txt"
//
//#include "PerfLog.h"
//namespace WTF {
//
//static bool gbLogEnable = false;
//
//typedef struct
//{
//	unsigned long startTick;
//	unsigned long endTick;
//}PerfLogItem;
//
//typedef struct
//{
//	unsigned long totalTime;
//	//unsigned long totalCount;
//	unsigned long startTick;
//	unsigned long totalPerfLogTime;
//	unsigned long minTime;
//	unsigned long maxTime;
//	std::vector<PerfLogItem> logItems;
//}WebPerfLog;
//
//
//// in simulator, std::string make some memory problem, so i make new string class
//class PerfLogString
//{
//public:
//	PerfLogString();
//	PerfLogString( char* szStr );
//	PerfLogString( const PerfLogString & other );
//	~PerfLogString();
//
//	PerfLogString & operator=(const PerfLogString &other);
//	bool operator==(const PerfLogString &other) const ;
//	bool operator<(const PerfLogString& other) const;
//
//	char* c_str() const ;
//private:
//	void copy( const PerfLogString& other );
//	char* m_pszStr;
//};
//
//PerfLogString::PerfLogString()
//{
//	m_pszStr = NULL;
//}
//
//PerfLogString::PerfLogString( char* szStr )
//{
//	m_pszStr = (char*)MemAlloc( AcStrlen(szStr) + 1 );
//	AcStrcpy( m_pszStr, szStr );
//}
//
//void PerfLogString::copy( const PerfLogString& other )
//{
//	if( m_pszStr != NULL )
//		MemFree( m_pszStr );
//
//	m_pszStr = (char*)MemAlloc( AcStrlen( other.c_str() ) +1 );
//	AcStrcpy( m_pszStr, other.c_str() );
//}
//
//char * PerfLogString::c_str() const
//{
//	return m_pszStr;
//}
//
//PerfLogString::~PerfLogString()
//{
//	MemFree( m_pszStr );
//	m_pszStr = NULL;
//}
//
//PerfLogString::PerfLogString( const PerfLogString & other )
//{
//	m_pszStr = NULL;
//	copy( other );
//}
//
//
//PerfLogString & PerfLogString::operator=(const PerfLogString &other)
//{
//	copy( other );
//	return *this;
//}
//
//
//bool PerfLogString::operator==(const PerfLogString &other) const
//{
//	if( AcStrcmp( m_pszStr, other.c_str() ) == 0 )
//		return true;
//	else
//		return false;
//}
//
//bool PerfLogString::operator<(const PerfLogString& other) const
//{
//	if( AcStrcmp( c_str(), other.c_str() ) > 0 )
//		return true;
//	else
//		return false;
//}
//
//std::map< PerfLogString, std::map<PerfLogString, WebPerfLog*>*>* gpWebPerfLogMap = NULL;
//
//void PerfLogStart( char* id, char* key)
//{
//	if( gbLogEnable == false )
//		return;
//
//	unsigned long tick = SFBSysGetTick();
//
//	if( gpWebPerfLogMap == NULL )
//	{
//		gpWebPerfLogMap = new std::map< PerfLogString, std::map<PerfLogString, WebPerfLog*>*>();
//	}
//
//	std::map< PerfLogString, std::map<PerfLogString, WebPerfLog*>*>::iterator pos;
//	pos = gpWebPerfLogMap->find( PerfLogString(id) );
//
//	std::map<PerfLogString, WebPerfLog*>* pPerfLog = NULL;
//
//	if( pos == gpWebPerfLogMap->end() )
//	{
//		pPerfLog = new std::map<PerfLogString, WebPerfLog*>();
//		std::pair< std::map< PerfLogString, std::map<PerfLogString, WebPerfLog*>*>::iterator, bool > pr;
//		PerfLogString strId = id;
//		//std::pair< PerfLogString, std::map<PerfLogString, WebPerfLog*>*> newpair( strId, pPerfLog );
//		pr = gpWebPerfLogMap->insert(std::make_pair( PerfLogString(id), pPerfLog ));
//		if( pr.second == false )
//		{
//			SysNeverGetHere();
//		}
//	}
//	else
//	{
//		pPerfLog = pos->second;
//	}
//
//	std::map<PerfLogString, WebPerfLog*>::iterator ppos;
//	ppos = pPerfLog->find( PerfLogString(key) );
//		
//	WebPerfLog* newLog = NULL;	
//
//	if( ppos == pPerfLog->end() )
//	{
//		newLog = new WebPerfLog();
//		newLog->startTick = tick;
//		newLog->totalTime = 0;
//		//newLog->totalCount = 0;
//		newLog->totalPerfLogTime = 0;
//		newLog->maxTime = 0;
//		newLog->minTime = 0xffffffff;
//
//		pPerfLog->insert( std::make_pair( PerfLogString(key), newLog ) );
//	}
//	else
//	{
//		newLog = ppos->second;
//		newLog->startTick = tick;
//	}
//	
//	newLog->totalPerfLogTime = newLog->totalPerfLogTime + (SFBSysGetTick() - tick);
//	
//}
//
//void PerfLogEnd( char* id, char* key)
//{
//	if( gbLogEnable == false )
//		return;
//
//	unsigned long tick = SFBSysGetTick();
//
//	if( gpWebPerfLogMap == NULL )
//	{
//		return;
//	}
//
//	PerfLogString strId = id;
//	std::map< PerfLogString, std::map<PerfLogString, WebPerfLog*>*>::iterator pos;
//	pos = gpWebPerfLogMap->find( strId );
//
//	std::map<PerfLogString, WebPerfLog*>* pPerfLog = NULL;
//
//	if( pos == gpWebPerfLogMap->end() )
//	{
//		return;
//	}
//	else
//	{
//		pPerfLog = pos->second;
//	}
//
//	std::map<PerfLogString, WebPerfLog*>::iterator ppos;
//	ppos = pPerfLog->find( PerfLogString(key) );
//
//	if( ppos == pPerfLog->end() )
//	{
//		return;
//	}
//	else
//	{
//		PerfLogItem logItem;
//		WebPerfLog* log = ppos->second;
//		ULONG elapsedTime;// = tick-log->startTick;
//
//		if( log->startTick == INVALID_TICK || log->startTick > tick )
//		{
//			SysDebugPrintf(  MID_EXCEPTION, "WTF::PerfLogEnd : \n" );
//			return;
//		}
//
//		logItem.startTick = log->startTick;
//		logItem.endTick = tick;
//		elapsedTime = logItem.endTick - logItem.startTick;
//
//		log->logItems.push_back( logItem );
//
//		//log->totalCount = log->totalCount + 1;
//		log->totalTime = log->totalTime + elapsedTime;
//
//		if( log->minTime > elapsedTime )
//			log->minTime = elapsedTime;
//		if( log->maxTime < elapsedTime )
//			log->maxTime = elapsedTime;
//		log->totalPerfLogTime = log->totalPerfLogTime + (SFBSysGetTick() - tick);
//
//		log->startTick = INVALID_TICK;
//	}
//}
//
//static HFile ghFile = INVALID_HOBJ;
//
//
//void PerfLogPrint( char* id )
//{
//	if( gbLogEnable == false )
//		return;
//
//	if( gpWebPerfLogMap == NULL )
//	{
//		return;
//	}
//
//	std::map< PerfLogString, std::map<PerfLogString, WebPerfLog*>*>::iterator pos;
//	pos = gpWebPerfLogMap->find( PerfLogString(id) );
//
//	std::map<PerfLogString, WebPerfLog*>* pPerfLog = NULL;
//
//	if( pos == gpWebPerfLogMap->end() )
//	{
//		return;
//	}
//	else
//	{
//		pPerfLog = pos->second;
//	}
//
//
//	if( pPerfLog->size() <= 0 )
//		return;
//
//	std::map<PerfLogString, WebPerfLog*>::iterator ppos;
//
//	
//	for (ppos = pPerfLog->begin(); ppos != pPerfLog->end(); ++ppos) 
//	{
//		WebPerfLog* log;
//		log = ppos->second;
//		const char *s = ppos->first.c_str();
//		SysDebugPrintf(  MID_EXCEPTION, "WTF::PerfLogPrint : id(%s), key(%s), count(%d), total(%d), min(%d), max(%d), logcalc(%d)\n"
//			, id, s, log->logItems.size(), log->totalTime, log->minTime, log->maxTime, log->totalPerfLogTime );
//
//		int len = 0;
//		len += 100;
//		len += AcStrlen(id);
//		len += AcStrlen(s);
//
//		char* szLog = (char*)MemAlloc( len );
//		AcSprintf( szLog, "%d, %s, %s\n",log->logItems.size(),id,  s );
//		FmWriteFile( ghFile, szLog, AcStrlen(szLog) );
//
//		if( ghFile != INVALID_HOBJ )
//		{
//			for(  int j = 0; j < log->logItems.size() ; j++ )
//			{
//				PerfLogItem logItem = log->logItems.at(j);
//				
//				AcSprintf( szLog, "%d,%d\n", logItem.startTick, logItem.endTick );
//				FmWriteFile( ghFile, szLog, AcStrlen(szLog) );
//	}
//}
//
//		MemFree( szLog );
//	}
//}
//
//
//
//void PerfLogClean( char* id )
//{
//	if( gpWebPerfLogMap == NULL )
//	{
//		return;
//	}
//
//	std::map< PerfLogString, std::map<PerfLogString, WebPerfLog*>*>::iterator pos;
//	pos = gpWebPerfLogMap->find( PerfLogString(id) );
//
//	std::map<PerfLogString, WebPerfLog*>* pPerfLog = NULL;
//
//	if( pos == gpWebPerfLogMap->end() )
//	{
//		return;
//	}
//	else
//	{
//		pPerfLog = pos->second;
//	}
//
//
//	std::map<PerfLogString, WebPerfLog*>::iterator ppos;
//
//	
//	for (ppos = pPerfLog->begin(); ppos != pPerfLog->end(); ++ppos) 
//	{
//		WebPerfLog* log;
//		log = ppos->second;
//		if( log )
//			delete log;
//	}
//
//
//
//
//	delete pPerfLog;
//
//	gpWebPerfLogMap->erase(pos) ;
//
//
//}
//
//
//void PerfLogPrintAll()
//{
//	if( gbLogEnable == false )
//		return;
//
//	if( gpWebPerfLogMap == NULL )
//	{
//		return;
//	}
//
//
//	FmRemoveFile( PERFLOG_PATH );
//	ghFile = FmCreateFile( PERFLOG_PATH, FM_CREATE || FM_WRITE );
//
//
//	std::map< PerfLogString, std::map<PerfLogString, WebPerfLog*>*>::iterator pos;
//
//	for( pos = gpWebPerfLogMap->begin(); pos != gpWebPerfLogMap->end(); ++pos )
//	{
//		PerfLogString id = pos->first;
//
//		PerfLogPrint( (char*)id.c_str() );
//	}
//
//	FmCloseFile(ghFile);
//}
//
//void PerfLogCleanAll()
//{
//
//	if( _SysGetDebugLevel() < SYS_DEBUG_LEVEL_MIDDLE )
//		gbLogEnable = false;
//	else
//	{
//		UINT32 diagnoseValue = (UINT32)SysGetDiagnoseInfo(GET_IDENT(MID_USER1)).debugCases;
//		if( diagnoseValue == 0x00 )
//			gbLogEnable = false;
//		else
//			gbLogEnable = true;
//	}
//
//
//	if( gpWebPerfLogMap == NULL )
//	{
//		return;
//	}
//
//	std::map< PerfLogString, std::map<PerfLogString, WebPerfLog*>*>::iterator pos;
//
//	for( pos = gpWebPerfLogMap->begin(); pos != gpWebPerfLogMap->end(); ++pos )
//	{
//		std::map<PerfLogString, WebPerfLog*>* pPerfLog =pos->second;
//
//		std::map<PerfLogString, WebPerfLog*>::iterator ppos;
//	
//		for (ppos = pPerfLog->begin(); ppos != pPerfLog->end(); ++ppos) 
//		{
//			WebPerfLog* log;
//			log = ppos->second;
//			if( log )
//				delete log;
//		}
//
//		delete pPerfLog;
//	}
//
//	delete gpWebPerfLogMap;
//	gpWebPerfLogMap = NULL;
//
//}
//
//
//
//PerfLog::PerfLog( char* id, char* key )
//{
//	m_pId = new char[AcStrlen(id)+1];
//	AcStrcpy( m_pId, id );
//
//	m_pKey = new char[AcStrlen(key)+1];
//	AcStrcpy( m_pKey, key );	
//
//	PerfLogStart( m_pId, m_pKey );
//}
//
//PerfLog::~PerfLog()
//{
//	PerfLogEnd( m_pId, m_pKey );
//
//	delete [] m_pId;
//	delete [] m_pKey;
//}
//
//} // namespace WTF
//
//#endif