@echo off
rem ======================================
rem Author: Pushparajan Vijayakumar (rajan.vp@samsung.com)
rem ======================================
rem
rem Build script for SFB BrowserEngine
rem Configuration: RELEASE
rem Compiler used: RVCT
rem

rem ========================================
rem Build configuration for Config.gmk
rem ========================================
set BUILD=KYRZ
set TARGET_NAME=F330
set TARGET=F330
set BTMODULE=BRCM_BT
set TARGET_BUILD_TYPE=LOLLIPOP
set TARGET_SDRAM_TYPE=SDRAM_1CS
set TARGET_BUILD_SHP_OPTION=-D_SHP_SUPPORT_DRM_V2 -DFEATURE_SAMSUNG_UNICON_BR_SFB -D_SHP_SUPPORT_MTP -D_SHP_UI_MUSIC -D_SHP_BGM_SUPPORT -D_SHP_SUPPORT_FM_RADIO -D_SHP_SUPPORT_MUSIC_RECOGNIZER -D_SHP_DB2_FTS -DFEATURE_SAMSUNG_RSS_READER -DFEATURE_SAMSUNG_HTML_VIEWER -D_SHP_CAMERA_UI_UNICON_1_0 -D_SHP_SIM_AUTO_SETTING
set TARGET_BUILD_MODEM_OPTION=-DFEATURE_SAMSUNG_QSHP -DFEATURE_SAMSUNG_LOLLIPOP -DFEATURE_SAMSUNG_SDCC -DFEATURE_SAMSUNG_1CS
set HS_BUILD_TYPE=WEDGE

rem ========================================
rem Environment variables for RVCT build
rem 
rem WARNING: Requires RVCT 2.2 [Build 616] present in C:\apps\rvds221 !!
rem
rem ========================================
IF "%SHPPATHSET%"=="TRUE" GOTO NOSET
set RVCTHOME=C:\apps\rvds221
set RVCT22BIN=%RVCTHOME%\RVCT\Programs\2.2\349\win_32-pentium
set RVCT22INC=%RVCTHOME%\RVCT\Data\2.2\349\include\windows
set RVCT22LIB=%RVCTHOME%\RVCT\Data\2.2\349\lib
set PATH=%RVCT22BIN%;%PATH%

set SHPPATHSET=TRUE

:NOSET

rem ========================================
rem Build configuration for mkrules.inc
rem ========================================

set CURRENT_TARGET=RVCT
set CURRENT_CONFIG=RELEASE

rem ========================================
rem Get required relative paths
rem ========================================
set OLDDIR=%CD%
chdir ..\..
set TOP=%CD%
chdir %OLDDIR%
set PATH=C:\Utils\Cygwin\bin;%PATH%
set MAINDIR=%TOP%\ShpWebkit\Make
set LOGDIR=%MAINDIR%
set ERRORLOG=%LOGDIR%\error.log
set BUILDLOG=build.log
set MAKEPARAMS=--quiet

TITLE SISO Webkit Build System
echo ----------------------------------------
echo CONFIGURATION - %CURRENT_CONFIG%/%CURRENT_TARGET%
echo ----------------------------------------
echo Backup old log in %BUILDLOG%
cp -rf %BUILDLOG% %BUILDLOG%.old
echo Removing the older log files
rm -rf %BUILDLOG%
rm -rf %ERRORLOG%
if NOT "%1"=="" goto TMP
:TMP
if "%2"=="clean" goto CLEANMOD
if "%1"=="" goto DEFAULT
if "%1"=="Memman" goto CUSTOM
if "%1"=="Javascriptcore" goto CUSTOM
if "%1"=="Webcore" goto CUSTOM
if "%1"=="Webkit" goto CUSTOM
if "%1"=="WTF" goto CUSTOM
if "%1"=="dftables" goto CUSTOM
if "%1"=="SFBCore" goto CUSTOM
if "%1"=="clean" goto DEFAULTCLEAN
echo
echo ===========================================================
echo Syntax: bSFB [<module-name>] [clean]
echo
echo Please use anyone of the following module:
echo 		Memman, Javascriptcore, Webcore, Webkit, WTF, SFBCore 
echo 
echo For cleaning a particular module give,
echo 		bSFB <module-name> clean
echo 
echo For full clean give,
echo 		bSFB clean
echo ============================================================
echo 
goto ERROR

:CUSTOM
echo ------------ Building %1 ---------------
make %MAKEPARAMS% -C "%MAINDIR%" -f main.gmk %1 | tee %BUILDLOG%
IF EXIST "%ERRORLOG%" type "%ERRORLOG%" >> %BUILDLOG%
IF EXIST "%ERRORLOG%" type "%ERRORLOG%"
IF NOT "%ERRORLEVEL%"=="0" GOTO ERROR
echo ------------   Build done    -----------
goto SUCCESS

:CLEANMOD
echo ------------ Cleaning %1 ---------------
make %MAKEPARAMS% -C "%MAINDIR%" -f main.gmk clean%1 | tee %BUILDLOG%
IF NOT "%ERRORLEVEL%"=="0" GOTO ERROR
echo ------------ Clean done      -----------
goto SUCCESS

:DEFAULT
echo ------------ Build all  -----------------
make %MAKEPARAMS% -C "%MAINDIR%" -f main.gmk all | tee %BUILDLOG%
IF EXIST "%ERRORLOG%" type "%ERRORLOG%" >> %BUILDLOG%
IF EXIST "%ERRORLOG%" type "%ERRORLOG%"
IF NOT "%ERRORLEVEL%"=="0" GOTO ERROR
echo ------------ Build done -----------------
goto SUCCESS

:DEFAULTCLEAN
echo ------------ Clean all  ---------------
make %MAKEPARAMS% -C "%MAINDIR%" -f main.gmk clean | tee %BUILDLOG%
IF NOT "%ERRORLEVEL%"=="0" GOTO ERROR
echo ------------ Clean done      ---------------
goto SUCCESS

:ERROR
echo --------------------------------------------------------
echo              Build Failed !!
echo --------------------------------------------------------
goto OUT

:SUCCESS
echo --------------------------------------------------------
echo             Check %BUILDLOG% for errors, if any
echo --------------------------------------------------------
goto OUT

:OUT
set /p input=Press Enter key to continue...
