#ifndef __MEM_CORE_H__
#define __MEM_CORE_H__

#ifdef __SHP__

#include "ShpJasmine.h"

//#if !defined(_SHP_SIMUL)
#if 1  /*Use SHP memory manager for simul and target */

#define CMM_LARGE_MALLOC(n)                     SFBalMemAllocWithPreCheck(n)
#define CMM_MALLOC(n)							SFBalMemAlloc(n)
#define CMM_CALLOC(n_elements, element_size)	SFBalMemCalloc(n_elements, element_size)
#define CMM_REALLOC(p, n)						SFBalMemRealloc(p, n)
#define CMM_LARGE_FREE(p)                       SFBalMemFree(p)
#define CMM_FREE(p)								SFBalMemFree(p)

#define CMM_MEMSET(pMem, value, length )		AcMemset(pMem, value, length)	
#define CMM_MEMCPY(pDest, pSrc, length )		AcMemcpy(pDest, pSrc, length)	

#define CMM_TOTAL_HEAP_SIZE						MemGetStat()->totalHeapSize
#define CMM_CURRENTLY_ALLOCATED_HEAP_SIZE		MemGetStat()->currentlyAllocatedMemSize

#else //#if _SHP_SIMUL

#define CMM_LARGE_MALLOC(n)                     malloc(n)
#define CMM_MALLOC(n)							malloc(n)
#define CMM_CALLOC(n_elements, element_size)	calloc(n_elements, element_size)
#define CMM_REALLOC(p, n)						realloc(p, n)
#define CMM_LARGE_FREE(p)                       free(p)
#define CMM_FREE(p)								free(p)

#define CMM_MEMSET(pMem, value, length )		memset(pMem, value, length)	
#define CMM_MEMCPY(pDest, pSrc, length )		memcpy(pDest, pSrc, length)	

#define CMM_TOTAL_HEAP_SIZE						MemGetStat()->totalHeapSize
#define CMM_CURRENTLY_ALLOCATED_HEAP_SIZE		MemGetStat()->currentlyAllocatedMemSize

#endif //#if !_SHP_SIMUL

#endif //__SHP__

#ifdef __GDK__

#pragma message "PP: Compile this on GDK port and check APIs"
#include "memory.h"

#define CMM_MALLOC(n)							malloc(n)
#define CMM_CALLOC(n_elements, element_size)	calloc(n_elements, element_size)
#define CMM_REALLOC(p, n)						realloc(p, n)
#define CMM_FREE(p)								free(p)
#define CMM_MEMSET(p, v, n)						memset(p, v, n)

#define CMM_TOTAL_HEAP_SIZE						1024
#define CMM_CURRENTLY_ALLOCATED_HEAP_SIZE		0

#endif //__GDK__

//#define __WIN32__

#ifdef __WIN32__

#include "c:\program files\microsoft visual studio 8\vc\include\stdlib.h"
#include "c:\program files\microsoft visual studio 8\vc\include\memory.h"

#define CMM_MALLOC(n)							malloc(n)
#define CMM_CALLOC(n_elements, element_size)	calloc(n_elements, element_size)
#define CMM_REALLOC(p, n)						realloc(p, n)
#define CMM_FREE(p)								free(p)
#define CMM_MEMSET(p, v, n)						memset(p, v, n)

#define CMM_TOTAL_HEAP_SIZE						1024
#define CMM_CURRENTLY_ALLOCATED_HEAP_SIZE		0

#endif //__WIN32__

#endif //__MEM_CORE_H__
