/*
* ==============================================================================
*  Name        : ObjectBase.inl
*  Part of     : MemMan
*  Description : Memory Manager inline methods
*  Version     : 1.0
* ==============================================================================
*/

#include "MemTypes.h"
#include "MemoryManager.h"

//------------------------------------------------------------------------------
// CObjectBase::operator new
//------------------------------------------------------------------------------
inline void* CObjectBase::operator new(guint aSize)
{
	return MemoryManager::Alloc( aSize );
}

//------------------------------------------------------------------------------
// CObjectBase::operator delete
//------------------------------------------------------------------------------
inline void CObjectBase::operator delete(void* aPtr)
{
	MemoryManager::Free(aPtr);
}

//------------------------------------------------------------------------------
// CObjectBase::operator placement new
//------------------------------------------------------------------------------
inline void* CObjectBase::operator new(guint, void* aPtr)
{
	return aPtr;
}

//------------------------------------------------------------------------------
// CObjectBase::operator placement delete
//------------------------------------------------------------------------------
inline void CObjectBase::operator delete(void*, void*)
{
}

//------------------------------------------------------------------------------
// CObjectBase::operator new
//------------------------------------------------------------------------------
inline void* CObjectBase::operator new [] (guint aSize)
{
	void* p = MemoryManager::Alloc(aSize);
	return p;
}

//------------------------------------------------------------------------------
// CObjectBase::operator delete
//------------------------------------------------------------------------------
inline void CObjectBase::operator delete [] ( void* aPtr )
{
	MemoryManager::Free( aPtr );
}
