
#ifndef _WEBCOREPAGEDATA_H_
#define _WEBCOREPAGEDATA_H_
//  INCLUDES

#include "PlatformString.h"

#if PLATFORM(SHP)
#include "CMMDefs.h"
#endif // PLATFORM(SHP)

namespace WebCore
{

class WebCorePageDataItem
CMM_MODIFIED
    {
    public:

        enum ePageDataItemType
            {
            EMarkup     = 0x01,
            EStylesheet = 0x02,
            EScript     = 0x04
            };

    public:    // Constructors and destructor

        /**
        * Constructor
        */
        WebCorePageDataItem( ePageDataItemType _itemType );

        /**
        * Destructor
        */
        virtual ~WebCorePageDataItem();


    public:   // New functions

        ePageDataItemType Type() { return m_itemType; }

        String Data() { return m_data; }

        String Url() { return m_url; }

        String ContentType() { return m_contentType; }

        int ContentLength() { 	return m_data.length();	}

    	String Charset() { return m_charset; }

        void SetData( String _data);

        void SetUrl( String _url );

        void SetContentType( String _contentType );

    	void SetCharset( String _charset );

    private:

        ePageDataItemType m_itemType;

        String m_data;

        String m_url;

        String m_contentType;

        String m_charset;

    };

}
#endif  //end of file
