#ifndef WEBCOREURLRESPONSEINFO_H
#define WEBCOREURLRESPONSEINFO_H

#include "HTTPHeaderMap.h"
//  INCLUDES

// CONSTANTS

// MACROS

// DATA TYPES

// FUNCTION PROTOTYPES

// FORWARD DECLARATIONS

// CLASS DECLARATION

using namespace WebCore;
/**
*
*  @lib resLoader.lib
*/
class IWebCoreUrlResponseHeaderInfo
    {
    public: // New functions

        /**
        *
        * @param
        * @return
        */
        virtual int TransId() const = 0;

        /**
        * Get top level info
        * @param
        * @return True this transaction is a top level one
        */
        virtual bool TopLevel() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual char* RequestUrl() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual char* ResponseUrl() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual eHttpStatus HttpStatus() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual unsigned int Method() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual char* ContentType() const = 0;

        /**
        *
        * @param
        * @return
        */
        // <TODO> : DateTime
        // virtual DateTime LastModified() = 0;

        /**
        *
        * @param
        * @return
        */
        virtual char* Charset() const = 0;

        /**
        *
        * @param
        * @return
        */
        // <TODO> : DateTime
        // virtual DateTime Expires() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual char* Boundary() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual char* ContentLocation() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual double ContentLength() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual const HTTPHeaderMap& ResponseHeaders() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual String ResponseHeadersString() const = 0;

        // <TODO> : Support reference counting
    };

/**
*
*  @lib resLoader.lib
*/
class IWebCoreUrlResponseInfo
    {

    public: // New functions

        /**
        *
        * @param
        * @return
        */
        virtual const void* Body() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual const int BodyLength() const = 0;

        /**
        *
        * @param
        * @return
        */
        virtual const IWebCoreUrlResponseHeaderInfo* HeaderInfo() const = 0;

    };

#endif      // WEBCOREURLRESPONSEINFO_H

// End of File
