/*
 * Copyright (C) 1999 Lars Knoll (knoll@kde.org)
 *           (C) 1999 Antti Koivisto (koivisto@kde.org)
 *           (C) 2000 Simon Hausmann <hausmann@kde.org>
 * Copyright (C) 2007 Apple Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */
#if defined(SHP_SUPPORT_WML)
#ifndef WMLAElement_h
#define WMLAElement_h

#include "HTMLAnchorElement.h"

#if defined ( SFB_SUPPORT_WMLSCRIPT )
#include "WMLScriptInterface.h"
#endif//SFB_SUPPORT_WMLSCRIPT
namespace WebCore {

#if defined ( SFB_SUPPORT_WMLSCRIPT )
class WMLScript ;
class WMLDocument ;
#endif//SFB_SUPPORT_WMLSCRIPT

//WML <a> tag
class WMLaElement : public HTMLAnchorElement
{
	public:
	
	 WMLaElement(Document*);
	 WMLaElement(const QualifiedName&, Document*);
    ~WMLaElement();
	//Nataraj
#if defined ( SFB_SUPPORT_WMLSCRIPT )
	void exeScript(const String& targetUrlPrefix, String &fragment ) ;
#endif//SFB_SUPPORT_WMLSCRIPT	
	void parseMappedAttribute(MappedAttribute *attr) ;
	virtual void defaultEventHandler(Event* evt) ;

};

} //WebCore
#endif //WMLAElement_h
#endif //SHP_SUPPORT_WML