/*
 * Copyright (C) 1999 Lars Knoll (knoll@kde.org)
 *           (C) 1999 Antti Koivisto (koivisto@kde.org)
 *           (C) 2000 Simon Hausmann <hausmann@kde.org>
 * Copyright (C) 2007 Apple Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */
#if defined(SHP_SUPPORT_WML)
#ifndef WMLGoElement_h
#define WMLGoElement_h

#include "HTMLAnchorElement.h"

#if defined ( SFB_SUPPORT_WMLSCRIPT )
#include "HTMLScriptElement.h"
#include "WMLScriptInterface.h"
#endif//SFB_SUPPORT_WMLSCRIPT
namespace WebCore {
//Nataraj
#if defined ( SFB_SUPPORT_WMLSCRIPT )
class WMLScript ;
class WMLDocument ;
#endif//SFB_SUPPORT_WMLSCRIPT

//WML <go> tag
class WMLGoElement : public HTMLAnchorElement
{
	public:
    WMLGoElement(Document*);
    ~WMLGoElement();

	void parseMappedAttribute(MappedAttribute *attr) ;
	virtual RenderObject *createRenderer(RenderArena* arena, RenderStyle* style) ;
	virtual void defaultEventHandler(Event* evt) ;
	virtual void handleEvent(EventType eventType, bool bForwardNavigation, bool & bIsEventHandled);
	void issueFetchRequest(String &url);
	void processHref(EventType eventType, bool bForwardNavigation);
	//Nataraj
#if defined (SFB_SUPPORT_WMLSCRIPT)
	void exeScript(const String& targetUrlPrefix, String &fragment ) ;
#endif//SFB_SUPPORT_WMLSCRIPT	
	String sendreferer() const;
    String method() const;
    	
	String href() const;
	String cache_control() const;
	String accept_charset() const;
	String enctype() const;

private:
	Event *m_tempEvent;
};


} // namespace WebCore

#endif // WMLGoElement_h
#endif