/*
 * Copyright (C) 1999 Lars Knoll (knoll@kde.org)
 *           (C) 1999 Antti Koivisto (koivisto@kde.org)
 * Copyright (C) 2004, 2005, 2006, 2007 Apple Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */
#if defined(SHP_SUPPORT_WML)
#include "config.h"
#include "HTMLNames.h"
#include "WMLNoopElement.h"


namespace WebCore {

using namespace HTMLNames;

WMLNoopElement::WMLNoopElement(Document *doc)
:HTMLElement(noopTag,doc)
{

}
WMLNoopElement::~WMLNoopElement()
{

}

void WMLNoopElement::handleEvent(EventType eventType, bool bForwardNavigation, bool & bIsEventHandled)
{
	//Noop specific functionality to be implemented here
	//Noop tag will not have any children, so no need to call children handleEvent
}
		
} //WebCore
#endif
