#if defined(SHP_SUPPORT_WML)

#include "config.h"
#include "Element.h"
#include "WMLOneventElement.h"
#include "AtomicString.h"
#include "CSSHelper.h"
#include "CSSPropertyNames.h"
#include "CSSValueKeywords.h"
#include "EventNames.h"
#include "HTMLDocument.h"
#include "HTMLNames.h"
#include "QualifiedName.h"
#include "WMLDocument.h"
#include "WMLBrowserContext.h"

namespace WebCore {

using namespace HTMLNames;


//WML <onevent> tag att
String WMLOneventElement :: type() const
{
    return getAttribute(typeAttr);
}
void WMLOneventElement::setType (const String &value)
{
    setAttribute(typeAttr, value);
}

String WMLOneventElement :: Class() const
{
    return getAttribute(classAttr);
}
void WMLOneventElement::setClass  (const String &value)
{
    setAttribute(classAttr, value);
}

String WMLOneventElement :: id() const
{
    return getAttribute(idAttr);
}
void WMLOneventElement::setId  (const String &value)
{
    setAttribute(idAttr, value);
}
WMLOneventElement::WMLOneventElement(Document *doc)
    :HTMLElement( oneventTag,doc) 
{
}
WMLOneventElement::~WMLOneventElement()
{
}

void WMLOneventElement::handleEvent(EventType eventType, bool bForwardNavigation, bool & bIsEventHandled)
{
	if(eventType == NavigationEvent)
	{
		if(bForwardNavigation && (type() == "onenterforward"))
		{
			if(true == bIsEventHandled)
			{
				return;
			}
			else
			{
				bIsEventHandled = true;
			}
		}
		else if((!bForwardNavigation) && (type() == "onenterbackward"))
		{
			if(true == bIsEventHandled)
			{
				return;
			}
			else
			{
				bIsEventHandled = true;
			}
		}

		if(((bForwardNavigation == true) && (type() == "onenterforward")) ||
		   ((bForwardNavigation == false) && (type() == "onenterbackward")))
		{
			//Just call children handleEvent() here
			//Child will be a task, calling child handleEvent will do the task
			for(Node *pChild = firstChild();pChild;pChild = pChild->nextSibling())
			{
				pChild->handleEvent(eventType,bForwardNavigation, bIsEventHandled);
			}
		}
	}
	else if(eventType == PickEvent)
	{
		if(type() == "onpick")
		{
			for(Node *pChild = firstChild();pChild;pChild = pChild->nextSibling())
			{
				pChild->handleEvent(eventType,bForwardNavigation, bIsEventHandled);
			}
		}
	}
	else if(eventType == TimerEvent && type() == "ontimer")
	{
		if(true == bIsEventHandled)
		{
			return;
		}
		else
		{
			bIsEventHandled = true;
		}

		EventType dummyEvent = NavigationEvent;
		for(Node *pChild = firstChild();pChild;pChild = pChild->nextSibling())
		{
			pChild->handleEvent(dummyEvent,bForwardNavigation, bIsEventHandled);
		}
	}
}

} //WebCore

#endif //SHP_SUPPORT_WML