/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		TextCodeSHP.h
 * @brief		Used by Jasmine Browser to encode and decode across different codecs and encodings.
 * @author		Zafar Hussain (zafar.h@samsung.com)
 * @version		1.0
 *
 */

#ifndef TextCodecSHP_h
#define TextCodecSHP_h

#include "TextCodec.h"
#include "TextEncoding.h"



namespace WebCore {

    class TextCodecSHP : public TextCodec {
    public:
        static void registerEncodingNames(EncodingNameRegistrar);
        static void registerBaseCodecs(TextCodecRegistrar);
		static void registerBaseEncodingNames(EncodingNameRegistrar registrar);

		static void registerExtendedEncodingNames(EncodingNameRegistrar);
        static void registerExtendedCodecs(TextCodecRegistrar);
        TextCodecSHP(const TextEncoding&);
        virtual ~TextCodecSHP();

        virtual String decode(const char*, size_t length, bool flush = false);
        virtual CString encode(const UChar*, size_t length, bool allowEntities = false);

    private:
        TextEncoding m_encoding;
    
    };

} // namespace WebCore

#endif // TextCodecICU_h
