/*
 * Copyright (c) 2007 Apple Inc.
 * All rights reserved.
 *
 */

#pragma once

#include <stdio.h>
#include <stdarg.h>
#include <stdint.h>
#include <locale.h>

typedef _locale_t locale_t;

#ifdef __cplusplus
    extern "C" {
#endif

#define _c_locale (_get_c_locale())
locale_t _get_c_locale();

#define atof_l _atof_l
#define atoi_l _atoi_l
#define isalnum_l  _isalnum_l
#define isalpha_l  _isalpha_l
#define isdigit_l  _isdigit_l
#define islower_l  _islower_l
#define isprint_l  _isprint_l
#define isspace_l  _isspace_l
#define isupper_l  _isupper_l
#define isxdigit_l _isxdigit_l
#define strtod_l _strtod_l
#define strtof_l(a,b,c) ((float)strtod_l((a),(b),(c)))
#define tolower_l  _tolower_l
#define toupper_l  _toupper_l
#define vsnprintf_l(str, size, loc, format, ap) (_vsnprintf_l((str), (size), (format), (loc), (ap)))
#define vfprintf_l(stream, loc, format, ap) _vfprintf_l((stream), (format), (loc), (ap))
#define strtol_l _strtol_l
#define strtoimax_l _strtoi64_l

int fprintf_l(FILE* stream, locale_t loc, const char * format, ...);
int snprintf_l(char * str, size_t size, locale_t loc, const char * format, ...);
const char * strcasestr_l(const char *big, const char *little, locale_t loc);
int sprintf_l(char * str, locale_t loc, const char * format, ...);

float exp2f (const float x);
float log2f (const float x);
float rintf(const float x);

#ifdef __cplusplus
    } /* extern "C" */
#endif
