/*
 * Copyright (c) 2007 Apple Inc.
 * All rights reserved.
 *
 */

#ifndef SafariTheme_h
#define SafariTheme_h

#if !defined(NDEBUG) && defined(USE_DEBUG_SAFARI_THEME)
#define SAFARITHEMEDLL L"SafariTheme_debug.dll"
#else
#define SAFARITHEMEDLL L"SafariTheme.dll"
#endif

typedef struct CGContext* CGContextRef;
struct CGRect;

namespace SafariTheme {
enum ThemePart {
    TextFieldPart,
    TextAreaPart,
    PushButtonPart,
    SquareButtonPart,
    PlasticButtonPart,
    SearchFieldPart,
    SearchFieldCancelButtonPart,
    SearchFieldResultsDecorationPart,
    SearchFieldResultsButtonPart,
    ScrollUpArrowPart,
    ScrollDownArrowPart,
    ScrollLeftArrowPart,
    ScrollRightArrowPart,
    VScrollThumbPart,
    HScrollThumbPart,
    VScrollTrackPart,
    HScrollTrackPart,
    SliderThumbPart,
    PopUpButtonPart,
    DropDownButtonPart,
    CheckboxPart,
    RadioButtonPart,
    FindBannerPreviousButtonPart,
    FindBannerNextButtonPart,
    ThemePartSentinel
};

typedef unsigned ThemeControlState;

enum ThemeControlStateMask {
    ActiveState = 1,
    PressedState = 1 << 1,
    EnabledState = 1 << 2,
    DefaultState = 1 << 3,
    CheckedState = 1 << 4,
    IndeterminateCheckedState = 1 << 5,
    FocusedState = 1 << 6
};

enum NSControlSize {
    NSRegularControlSize,
    NSSmallControlSize,
    NSMiniControlSize
};

typedef void (__stdcall*paintThemePartPtr)(ThemePart, CGContextRef, const CGRect&, NSControlSize, ThemeControlState);

}
#endif
