/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IHttpChannel..h
 * @brief		Define interface of URILoader IHttpChannel
 * @author	Sangheon Kim (sangheon77.kim@samsung.com)
 * @version	1.0
 * @date		2008.03.05	v1.0		Created
 */
#ifndef __IPDPContextListener_Defined
#define __IPDPContextListener_Defined

#include "URILoader.h"

namespace URILoader
{


typedef int PDPContextStatus;

/**
* 
*/
class IPDPContextListener : public IUnknown
{
public:

	/***************************************************************************
	*
	* Constants
	*
	****************************************************************************/
	/**
	 */
	static const PDPContextStatus PDPCONTEXT_STARTING = 1;
	static const PDPContextStatus PDPCONTEXT_STARTED = 2;
	static const PDPContextStatus PDPCONTEXT_STOPPING = 3;
	static const PDPContextStatus PDPCONTEXT_STOPPED = 4;
	

	/***************************************************************************
	*
	* Funtions
	*
	****************************************************************************/
	/**
	* Called whenever the status of PDP context has been changed
	*/
	virtual Result OnStatusChanged( PDPContextStatus nStatus, int nParam1, int nParam2, void* pParam ) = 0;

	/**
	* Called when other PDP context is alread activated, so this PDP context must be deactivated to activte new PDP context.
	*/
	//virtual Result OnConfirmDeactivateOtherPDPContext(  IPDPContextSender* pSender  ) = 0;
	

};



} // namespace 

#endif //__IPDPContextListener_Defined
