/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IDOMHtml.h
 * @brief		Define interface DOM level 2 Html
 * @author	Chaehwan Li (chaehwan.li@samsung.com)
 * @version	1.0
 * @date		2008.03.14	v1.0		Created
 */

#ifndef __IDOMHtml_Defined
#define __IDOMHtml_Defined

#include "WebDefs.h"

namespace	WebControl
{

class IDOMHtmlDocument
{
public:
	virtual HRESULT getTitle( char* out_pBuf, int in_nBufSize ) = 0;
	virtual HRESULT getURL( char* out_pBuf, int in_nBufSize ) = 0;
	virtual HRESULT getLastModified( char* out_pBuf, int in_nBufSize ) = 0;

	// [todo] add more funtions in DOM spec
	// domain
	// cookie
	// referrer
	// images[]
	// links[] 
	// anchors[] 
};

}


#endif // __IDOMHtml_Defined