/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IIMESender.h
 * @brief		Define interface IIMESender of WebControl
 * @author	Chaehwan Li (chaehwan.li@samsung.com)
 * @version	1.0
 * @date		2008.03.14	v1.0		Created
 */

#ifndef __IIMESender_Defined
#define __IIMESender_Defined

#include "WebDefs.h"

namespace	WebControl
{

class IIMESender
{
public:
	/*
	 * @desc this sender called when finished input on IME
	 * @param in_length length of inputted text
	 * @return HRESULT
	 */
	virtual HRESULT OK( int in_length ) = 0;

	/*
	 * @desc this sender called when canceled.
	 * @param 
	 * @return HRESULT
	 */
	virtual HRESULT Cancel( void ) = 0;

};

} // namespace WebControl

#endif // __IIMESender_Defined