/**
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

/**
 *  This file is about ECOM service.
 * 
 * @name        WebControlECOM.h
 * @author      Zafar Hussain ( zafar.h@samsung.com )
 */


#ifndef _WEBCONTROL_ECOM_H_
#define _WEBCONTROL_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifdef _SHP_CALL_DLL_WEBCONTROL
extern __declspec(dllimport) EcomFactory* pDllBaseEcomFactory;
extern __declspec(dllimport)  ADDR dllBaseSb;
#endif 
	/*
 * ECOM Interface
 */
ECOM_INTERFACE(EWebControl)
{
	DECLARE_EBASE()
	BOOL			(*GNULibxmlDispatch)	(UINT32 action, ULONG param1, ULONG param2, void* pParam3);
#ifdef __cplusplus
	int             (*WCCreateIControl)           (char *,int,int,int,int,int,WebControl::IControl **,WebControl::GCType);
	URILoader::ILoadGroup*		(*WCCreateClientLoadGroup)		(char* appName);
	void						(*WCDestroyClientLoadGroup)		(URILoader::ILoadGroup* clinetID);
	int             (*WCGetWebControlCount)           ();
#endif
};

/*
 * Interface Accessor
 */
#if (defined(USING_WEBKIT) || defined(_SHP_SIMUL) && defined(_SHP_CALL_DLL_WEBCONTROL)) || (defined(_SHP_DLL) && ! defined(_SHP_DLL_WEBCONTROL) && ! defined(_SHP_CALL_DLL_WEBCONTROL))
#	define		CreateIControl			        (__WebControlGetVtbl()->WCCreateIControl)
#	define		LibxmlDispatch					(__WebControlGetVtbl()->GNULibxmlDispatch)
#	define		CreateClientLoadGroup			(__WebControlGetVtbl()->WCCreateClientLoadGroup)
#	define		DestroyClientLoadGroup			(__WebControlGetVtbl()->WCDestroyClientLoadGroup)
#	define		GetWebControlCount				(__WebControlGetVtbl()->WCGetWebControlCount)
#endif 


/**
 * @struct 
 * 
 *  ECOM Type
 * @see        related information ( function name, module name, etc )
 */
typedef struct
{
	DECLARE_ECOM_VTBL(EWebControl)
	UINT32		refCount;
} TWebControl;

extern TWebControl gWebControl;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _WEBCONTOL_ECOM_H_


