/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IUnknown.cpp
 * @brief		implement IUnknown of WebControl
 * @author	Sangheon Kim (sangheon77.kim@samsung.com)
 * @version	1.0
 * @date		2008.03.18	v1.0		Created
 */

#include "IUnknown.h"
#include <wtf/FastMalloc.h>

namespace WebControl {


/**
* default implementation for Release of WebControl
* Each class of WebControl can overide this funtion.
*/
void IUnknown::Release()
{
	// WebControl is seperated dll and its object is created inside dll, 
	// so if client delete the object using c++ delete, the object memory will not be free correctly.
	// Because Jasmine use its own overrided new/delete, this global delete will be overrieded to Jasmine's memory manager.
	::delete this;
}

IUnknown::~IUnknown()
{
}

} // namespace WebFrame