/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		WebDOMHtml.h
 * @brief		implement DOM level 2 Html
 * @author	Sangheon Kim (sangheon77.kim@samsung.com)
 * @version	1.0
 * @date		2008.03.25	v1.0		Created
 */
#ifndef __WebDOMHtml_Defined
#define __WebDOMHtml_Defined

#include "IDOMHtml.h"
#include "WebDOMCore.h"

#include "Document.h"


namespace	WebControl
{

class DOMHtmlDocument : public DOMDocument, public IDOMHtmlDocument
{
public:
	DOMHtmlDocument( WebCore::Document* pDoc );

public:
	virtual HRESULT getTitle( char* out_pBuf, int in_nBufSize );
	virtual HRESULT getURL( char* out_pBuf, int in_nBufSize );
	virtual HRESULT getLastModified( char* out_pBuf, int in_nBufSize );
};

} // namespace  WebFrame

#endif // __WebDOMHtml_Defined