/**
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

/**
 *  This file is about ECOM service.
 * 
 * @name        LibxmlECOM.h
 * @author      Zafar Hussain ( zafar.h@samsung.com )
 */


#ifndef _LIBXML_ECOM_H_
#define _LIBXML_ECOM_H_

#include <libxml/parser.h>
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * ECOM Interface
 */
ECOM_INTERFACE(ELibxml)
{
	DECLARE_EBASE()
	
	xmlChar *         (*GetProp)					(xmlNodePtr, const xmlChar *);

	int               (*Strcmp)						(const xmlChar *, const xmlChar *);

	xmlChar *         (*NodeListGetString)			(xmlDocPtr , xmlNodePtr , int );

	xmlDocPtr         (*ReadDoc)					(const xmlChar *, const char *, const char *, int);

	void              (*FreeDoc)					(xmlDocPtr); 

	xmlNodePtr		  (*DocGetRootElement)			(xmlDocPtr);


};

/*
 * Interface Accessor
 */
#if (defined(USING_LIBXML) || defined(_SHP_SIMUL) && defined(_SHP_CALL_DLL_LIBXML)) || (defined(_SHP_DLL) && ! defined(_SHP_DLL_LIBXML) && ! defined(_SHP_CALL_DLL_LIBXML))

#define		xmlGetProp			        (__LibxmlGetVtbl()->GetProp)
#define		xmlStrcmp			        (__LibxmlGetVtbl()->Strcmp)
#define		xmlNodeListGetString		(__LibxmlGetVtbl()->NodeListGetString)
#define		xmlReadDoc			        (__LibxmlGetVtbl()->ReadDoc)
#define		xmlFreeDoc			        (__LibxmlGetVtbl()->FreeDoc)
#define		xmlDocGetRootElement       (__LibxmlGetVtbl()->DocGetRootElement)
#endif 


/**
 * @struct 
 * 
 *  ECOM Type
 * @see        related information ( function name, module name, etc )
 */
typedef struct
{
	DECLARE_ECOM_VTBL(ELibxml)
	UINT32		refCount;
} TLibxml;

extern TLibxml gLibxml;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _LIBXML_ECOM_H_


