/**
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

/**
 *  Libxml uses BAL functionalities, which are exposed thru UrlLoaderECOM.h.
 * But, Libxml being a C project throws errors on including UrlLoaderECOM.h.
 * This file aims to achieve a work around the above problem.
 * 
 * @name        BalPointers.h
 * @author      Zafar Hussain ( zafar.h@samsung.com )
 */

#ifndef _BALPOINTERS_H_
#define _BALPOINTERS_H_
#include "MemMgr.h"
#if 0
typedef struct 
{
	void* (*gLibxmlMemAlloc)	(UINT32 );
	void* (*gLibxmlMemCalloc)   (UINT32 , UINT32);
	void* (*gLibxmlMemRealloc)	(void *, UINT32);
	void  (*gLibxmlMemFree)		(void *);
}Libfptr;

#if defined(__cplusplus)
extern "C" {
#endif

#ifdef LIBXML_INTERNAL_USE
//Libfptr *gpLibPtr;
//#else
extern Libfptr *gpLibPtr;
#endif 

// Will be called from the dispatch function of Libxml's ECOM

void __InitLibxml();

#if defined(__cplusplus)
}
#endif

#endif


#ifdef LIBXML_INTERNAL_USE
#define		SFBalMemAlloc			MemAlloc //        (*gpLibPtr->gLibxmlMemAlloc)
#define		SFBalMemCalloc		MemCalloc //	        (*gpLibPtr->gLibxmlMemCalloc)
#define		SFBalMemRealloc			MemReAlloc	 //	(*gpLibPtr->gLibxmlMemRealloc)
#define		SFBalMemFree			MemFree //		(*gpLibPtr->gLibxmlMemFree)
#endif 

#endif // _BALPOINTERS_H