#ifndef _WS_COMMON_H
#define _WS_COMMON_H

#ifdef __cplusplus
extern "C" {
#endif

#define FEATURE_SETUP_WIZARD

#include "WmWinCore.h"
#include "WsMainShapeConfig.h"
#include "WsSubShapeConfig.h"
#include "WsColorConfig.h"
#include "WsFontConfig.h"
#include "ShpConfig.h"
#include "BootMgr.h"

#define		WINDOWSET_TITLE_LEN_MAX 128

typedef enum
{
	WINDOW_EDITAREA		= (EXTENDED_WINDOW_TYPE + 7),	// 7
	WINDOW_EDITFIELD	= (EXTENDED_WINDOW_TYPE + 8),	// 8
	WINDOW_LISTEX		= (EXTENDED_WINDOW_TYPE + 11),	// 11
	WINDOW_MESSAGEBOX	= (EXTENDED_WINDOW_TYPE + 14),	// 14
	WINDOW_COMBOBOX		= (EXTENDED_WINDOW_TYPE + 28),	// 28
} WmWindowType;

typedef enum
{
	WS_SCREEN_MODE_0 = 0
} WsMainScreenMode;

typedef enum
{
	WS_SUB_SCREEN_MODE_0 = 0
} WsSubScreenMode;

typedef enum
{
	WINDOW_EFFECT_V_SLIDE
} WsEffect;

typedef enum {
	WINDOW_SYSTEM_COLOR_MIN = 0
}WsSystemColor;

typedef enum
{
	EFFECT_STATUS_NA,
} WsEffectStatus;

#define WINSET_COLOR_TABLE_MAX		461

typedef struct
{
	COLOR	colorTable[WINSET_COLOR_TABLE_MAX + 1];
} WsColorTable;

#define SET_WINSET_NOTIFY_BASE(X)		((UINT16)((X & MASKL8) << 8))
#define	COMBOBOX_NOTIFY_BASE			SET_WINSET_NOTIFY_BASE(0x05)	
#define	VEDIT_NOTIFY_BASE				SET_WINSET_NOTIFY_BASE(0x2B)
#define	VEDIT_NOTIFY_SELECTED			SET_WINSET_NOTIFY_BASE(0x2D)
#define	COMBOBOX_NOTIFY_ITEM_SELECTED	(COMBOBOX_NOTIFY_BASE + 0x01)	
#define	COMBOBOX_NOTIFY_CLOSEUP			(COMBOBOX_NOTIFY_BASE + 0x03)			
#define VEDIT_NOTIFY_CANCELED 			(VEDIT_NOTIFY_BASE + 0x02)

WmBitmap* __WsLoadBitmap( char szFile[], int rsrcID );
BOOL __WsFreeBitmap(WmBitmap* pbmBitmap);

#define __WsFreeBitmap(pbmBitmap) __WmFreeBitmap(pbmBitmap)

#ifdef __cplusplus
}
#endif 

#endif
