#ifndef _WS_EDITAREA_H_
#define _WS_EDITAREA_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "WsCommon.h"
#include "AvPlayer.h"
#include "WsEditCommon.h"
#include "WsEditCommonDisplay.h"
#include "WmText.h"

typedef enum {
	EDITAREA_LETTERMODE_NORMAL,											
	EDITAREA_LETTERMODE_SMALL,		
	EDITAREA_LETTERMODE_CAPITAL	
} WsEditAreaLetterMode;

#define EDITAREA_STYLE_NOINDEX			0x00000001
#define EDITAREA_STYLE_DRAW_BORDER		0x00002000

HWIN	WsCreateEditArea ( HWIN hWinParent, int editAreaStyle, int rectX, int rectY, int rectW, int rectH, WmEventMapEntry* pEventMap );
int		WsGetEditAreaLimitLength ( HWIN hWin );
BOOL	WsSetEditAreaLimitLength ( HWIN hWin, int length );
BOOL	WsSetEditAreaText ( HWIN hWin, MCHAR* mszText );
BOOL	WsGetEditAreaText ( HWIN hWin, MCHAR* pmszTextBuf, int length );
int		WsGetEditAreaTextLength ( HWIN hWin );
BOOL	WsSetEditAreaCursorPos ( HWIN hWin, int cursorPos );
BOOL	WsSetEditAreaCategory ( HWIN hWin, WsEditCategory category, BOOL bEnable );
BOOL	WsSetEditAreaLetterMode ( HWIN hWin, WsEditAreaLetterMode letterMode );
BOOL	WsSetEditAreaInputMode ( HWIN hWin, WsEditInputMode inputMode );
BOOL	WsGetEditAreaInputMode ( HWIN hWin, WsEditInputMode* pInputMode );
BOOL	WsSetEditAreaInputAlphabetMode( HWIN hWin, WsEditLetterMode capsMode);
BOOL	WsEditAreaCursorIsInFirstLine ( HWIN hWin );
BOOL	WsSetEditAreaFont(HWIN hWin, HFNT hFont);

#ifdef __cplusplus
}
#endif

#endif