#ifndef _WS_EDITFIELD_H_
#define _WS_EDITFIELD_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "WsCommon.h"
#include "AvPlayer.h"
#include "WsEditCommon.h"
#include "WsEditCommonDisplay.h"
#include "WmText.h"

#define EDITFIELD_STYLE_NORMAL						0x00000001		
#define EDITFIELD_STYLE_PASSWORD					0x00000002		
#define EDITFIELD_STYLE_TITLE_LEFT					0x00000008		
#define EDITFIELD_STYLE_TITLE_TOP					0x00000010		
#define EDITFIELD_STYLE_THIN_BORDER					0x00000200	
#define EDITFIELD_STYLE_INDEX						0x00001000		
#define EDITFIELD_STYLE_NO_BACKGROUND				0x00080000	
#define EDITFIELD_STYLE_TITLE_AUTOROTATE			0x00400000

typedef enum {
	EDITFIELD_LIMITLENGTH_BYTE,
} WsEditFieldLimitLengthType;

HWIN	WsCreateEditField ( HWIN hWinParent, int editFieldStyle, int rectX, int rectY, int rectW, int rectH, WmEventMapEntry* pEventMap );
int		WsGetEditFieldLimitLength ( HWIN hWin );
BOOL	WsSetEditFieldLimitLength ( HWIN hWin, int length );
BOOL	WsSetEditFieldText ( HWIN hWin, MCHAR* mszText );
BOOL	WsGetEditFieldText ( HWIN hWin, MCHAR* pmszTextBuf, int length );
int		WsGetEditFieldTextLength ( HWIN hWin );
BOOL	WsSetEditFieldCursorPos ( HWIN hWin, int cursorPos );
BOOL	WsGetEditFieldInputMode ( HWIN hWin, WsEditInputMode* pInputMode );
BOOL	WsSetEditFieldInputMode ( HWIN hWin, WsEditInputMode inputMode );
BOOL	WsSetEditFieldCategory(HWIN hWin, WsEditCategory category, BOOL bEnable);
BOOL	WsSetEditFieldTitle ( HWIN hWin, MCHAR* mszTitle );
BOOL	WsGetEditFieldLimitLengthType ( HWIN hWin, WsEditFieldLimitLengthType* limitLengthType );

#ifdef __cplusplus
}
#endif

#endif